<template>
	<transition name="bounce">
		<div class="selector-container">
			<Next
				class="animate"
				v-if="localizationOptions.length == 0"
				@click="$emit('select')"
				size="50px"
			></Next>
			<div
				v-for="(option,index) of localizationOptions"
				:key="index"
				@click="select(option.language,option.currency)"
				class="flag-container"
			>
				<img :src="option.iconURL" class="flag animate" alt />
				<span class="name">{{option.name}}</span>
			</div>
		</div>
	</transition>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import Next from '@/components/Next.vue'
import Localization from '../models/Localization'
@Component({
	components: {
		Next
	}
})
export default class LanguageSelector extends Vue {
	localizationOptions: Array<Localization> = this.$store.state.menu
		? this.$store.state.menu.localizations.sort((c: Localization, n: Localization) => c.order - n.order)
		: []
	select(language: string, currency = '') {
		this.$store.dispatch('changeCurrency', currency)
		this.$store.dispatch('changeLanguage', language)
		this.$emit('select')
	}
}
</script>
<style scoped>
.selector-container {
	position: relative;
	display: flex;
}

.flag-container {
	display: flex;
	flex-direction: column;
	align-items: center;
	width: 70px;
	margin: 0px 10px 0px 10px;
}

.flag {
	width: 50px;
}
.name {
	color: white;
	text-shadow: 1px 1px 2px black;
}

.next-button {
	display: flex;
	background-color: white;
	border-radius: 50%;
	width: 50px;
	height: 50px;
	align-items: center;
	justify-content: center;
	font-size: 30px;
}

.animate {
	animation-name: scale;
	animation-duration: 1.5s;
	backface-visibility: hidden;
	animation-delay: 1.5s;
	animation-iteration-count: 2;
}


@keyframes scale {
	0% {
		transform: scale(1, 1) translateY(0);
	}
	10% {
		transform: scale(1.1, 0.9) translateY(0);
	}
	30% {
		transform: scale(0.9, 1.1) translateY(-30px);
	}
	50% {
		transform: scale(1, 1) translateY(0);
	}
	57% {
		transform: scale(1, 1) translateY(-7px);
	}
	64% {
		transform: scale(1, 1) translateY(0);
	}
	100% {
		transform: scale(1, 1) translateY(0);
	}
}
</style>
